import React from 'react';
import {observer, inject} from 'mobx-react';
import bind from 'bind-decorator';
import {
  Card,
  CardActions,
  CardHeader,
  CardMedia,
  CardTitle,
  AutoComplete,
  CardText,
  FlatButton,
  Divider,
  RaisedButton,
  Toolbar,
  DatePicker,
  FontIcon,
  SelectField,
  MenuItem,
  ToolbarGroup,
  FloatingActionButton,
  ToolbarSeparator,
  IconButton,
  ToolbarTitle,
  RadioButton, RadioButtonGroup, DropDownMenu,
  Tabs, Tab,
} from 'material-ui';
import {withRouter} from 'react-router';
import {BrowserRouter as Router, Route} from 'react-router-dom';
import StarBorder from 'material-ui/svg-icons/toggle/star-border';
import ContentAdd from 'material-ui/svg-icons/content/add';
import SnackbarMessage from '../SnackbarMessage';
import '../style.scss';
import {appConfig} from "../../../config/app";
import CheckSchedule from "./CheckSchedule";
import ListBus from "./ListBus";
import FormBook from './FormBook';
import Confirmation from './Confirmation';

@inject('appstate')
@observer
export default class Bus extends React.Component {
  constructor(props) {
    super(props);
    this.props = props;
    this.state = {
      value: 0,
      openSnackbar: false
    };
    this.defaultState = Object.assign({}, this.state);
    this.http = props.appstate.http;
    this.authStore = props.appstate.auth;
  }

  componentDidMount() {
    console.log('Profile loaded!');

  }

  handleClickFind = () => {
    this.setState({
      value: 1
    })
  };

  handleClickBack = () => {
    this.setState({
      value: 0
    })
  };

  handleChooseBus = (bus) => {
    this.setState({
      value: 2,
      busData: bus,
    })
    console.log(bus);
  };

  handleBackForm = (event, index, value) => {
    this.setState({
      value: 1
    })
  }

  getData = (object) => {
    this.setState({
      passangerData: object
    })
    console.log(object);
  };

  handleClickConfirmation = () => {
    this.setState({
      value: 3
    })
  };

  handleBackCofirmation = () => {
    this.setState({
      value: 2
    })
  }

  handleBookNow = () => {
    this.setState({
      value: 0,
      openSnackbar: true,
    })
  };

  handleCloseSnackbar = () => {
    this.setState({
      openSnackbar: false
    })
  };

  render() {

    return (
      <div className="row">
        <div className="col s12">
          {(this.state.value == 0) ? <CheckSchedule onClickFind={this.handleClickFind} getData={this.getData}/> : ''}
          {(this.state.value == 1) ?
            <ListBus onClickBack={this.handleClickBack} onClickSubmit={this.handleChooseBus}/> : ''}
          {(this.state.value == 2) ? <FormBook busData={this.state.busData} passangerData={this.state.passangerData}
                                               onConfirm={this.handleClickConfirmation}
                                               onClickBack={this.handleBackForm}/> : ''}
          {(this.state.value == 3) ?
            <Confirmation onClickBack={this.handleBackCofirmation} onClickBookNow={this.handleBookNow}/> : ''}
          <SnackbarMessage message='Booking Succeed' open={this.state.openSnackbar}
                           closeSnackbar={this.handleCloseSnackbar}/>
        </div>
      </div>
    )
  }
}
